/********************************************************************************************
(C) Jakub Borzdynski 2006
jotbeage@interia.pl
-----------------------------
Szkola Konstruktorow 137 - g-meter
-----------------------------
Wykonywanie pomiarow za pomoca czujnika przyspieszenia.
********************************************************************************************/
#ifndef jb_adxl_h
#define jb_adxl_h

#define sbi(port, bit) port|=(1<<bit)
#define cbi(port, bit) port&=~(1<<bit)
#define F_CPU 1000000UL

#include <avr/io.h> //definicje rejestrow uK
#include <util/delay.h>
#include <math.h>
#include "lcd.h" 
#include "eeprom.h" 

//slowa sterujace
#define POMIAR_G		0 //chwilowe przyspieszenie
#define POMIAR_G_MAX	1 //maksymalne przyspieszenie w jednostce czasu
#define POMIAR_ST		2 //pomiar kata

#define KANAL_X		4
#define KANAL_Y		3
#define KANAL_X_AMP	5
#define KANAL_Y_AMP	2

//-------------------------------------------------------------------------------------------------------------
class adxl{
	//zachowane pomiary: X, Y, Xamp, Yamp
	unsigned long suma[4] ; //obliczanie sredniej
	unsigned int srednia[4] ; //wyznaczona srednia
	
	//zmienne wykorzystywane w obliczeniach
	unsigned int ostatni_pomiar ; //ostatni, wyznaczony pomiar
	unsigned int zliczono  ; //zliczanie pomiarow
	unsigned int ile ; //z ilu pomiarow wyciagac srednia
	
	//parametry pracy ukladu
	unsigned int x[4] ; //skrajne wartosci dla osi X (Gmin, Gmax, AMPmin, AMPmax) ;
	unsigned int y[4] ; //skrajne wartosci dla osi Y (Gmin, Gmax, AMPmin, AMPmax) ;
	
	unsigned int zmierz(unsigned char nr_kanalu) ;
	unsigned int pomiar_usredniony(unsigned char nr_kanalu) ;
	//-----------------------------------------------------------
	public:
	adxl() ; //konstruktor
	unsigned int operator()(char tryb) ;
	void konfiguracja() ;
} ;


#endif