/********************************************************************************************
(C) Jakub Borzdynski 2006
jotbeage@interia.pl
-----------------------------
Szkola Konstruktorow, zad 128
Domowa stacja monitoringu. Odczyt z wewnetrznej pamieci EEPROM
********************************************************************************************/
#ifndef jb_eeprom_cpp
#define jb_eeprom_cpp
#include "eeprom.h"

eeprom::eeprom(){
	;
}

void eeprom::zapisz(unsigned int adres, unsigned int data){
	//zerowanie watchdoga
	asm("wdr") ;
	
	//zapis 8 bitow MSB
	while(bit_is_set(EECR, EEPE)){;} //oczekiwanie na pozwolenie zapisu
	EEAR = adres ; //adres
	EEDR = (data>>8)&0x00FF ; //zapisz dane
	EECR = 0x04 ;
	sbi(EECR, EEPE) ;
	
	//zapis 8 bitow LSB
	while(bit_is_set(EECR, EEPE)){;} //oczekiwanie na pozwolenie zapisu
	EEAR = adres + 1; //adres
	EEDR = (data&0x00FF) ; //zapisz dane
	EECR = 0x04 ;
	sbi(EECR, EEPE) ;
}

unsigned int eeprom::operator[](unsigned int adres){
	//sprawdz, czy dane nie sa obecnie zapisywane
	while(bit_is_set(EECR, EEPE)){;}

	//odczyt 8 bitow MSB
	EEAR = adres ; //ustaw adres
	sbi(EECR, EERE) ; //polecenie odczytu
	unsigned char temp = EEDR ;
	
	//odczyt 8 bitow LSB
	EEAR = adres + 1; //ustaw adres
	sbi(EECR, EERE) ; //polecenie odczytu
	
	//zwroc rezultat
	return temp*256 + EEDR ;
}

//deklaracja obiektu do obslugi pamieci
eeprom pamiec ; 

#endif